#!/usr/bin/perl

use NetSNMP::agent(':all');
use NetSNMP::ASN qw(ASN_OCTET_STR);

my $rootOID=".1.3.6.1.4.1.8072.9999.9999.7368816";
my $regoid=new NetSNMP::OID($rootOID);

sub get_record
{
    my $filename = shift;
    open FILE, $filename or return 0;
    chomp(my $record = <FILE>);
    close FILE;
    return $record;
}

sub ppp_stats_handler
{
    my ($handler,$registration_info,$request_info,$requests)=@_;
    my $request;

    for($request=$requests; $request; $request=$request->next())
    {
        my $oid=$request->getOID();
        if ($request_info->getMode()==MODE_GET)
        {
            my $ppp;
            if(substr($oid,0,length("$rootOID."))=="$rootOID.")
            {
                $ppp=substr($oid,length("$rootOID."));
            }
            elsif(substr($oid,0,length("$regoid."))=="$regoid.")
            {
                $ppp=substr($oid,length("$regoid."));
            }
            if(defined($ppp))
            {
                my $tx=&get_record("/sys/class/net/ppp$ppp/statistics/tx_bytes");
                my $rx=&get_record("/sys/class/net/ppp$ppp/statistics/rx_bytes");
                my $output=sprintf "%d %d",$rx,$tx;
                $request->setValue(ASN_OCTET_STR,$output);
            }
        }
    }
}

my $agent=new NetSNMP::agent();
$agent->register("ppp_stats",$rootOID,\&ppp_stats_handler);
